# Visualization
TKMeshVS
MeshVS

# MeshVS_SensitivePolyhedron Class Reference

`#include <MeshVS_SensitivePolyhedron.hxx>`

Inheritance diagram for MeshVS_SensitivePolyhedron:

[legend]

## Public Member Functions

Standard_EXPORT | MeshVS_SensitivePolyhedron (const Handle(SelectBasics_EntityOwner)&Owner, const TColgp_Array1OfPnt &Nodes, const Handle(MeshVS_HArray1OfSequenceOfInteger)&Topo)
virtual Standard_EXPORT void | Project (const Select3D_Projector &aProjector)
| Returns the projector aProjector. In classes inheriting this framework, you must redefine this function in order to get a sensitive 2D rectangle from a 3D entity. This rectangle is the sensitive zone which makes the 3D entity selectable. .
virtual Standard_EXPORT Handle_Select3D_SensitiveEntity | GetConnected (const TopLoc_Location &aLocation)
| Returns the sensitive entity found at the location aLocation. You must redefine this function for any type of sensitive entity which can accept another connected sensitive entity.//can be connected to another sensitive entity. .
virtual Standard_EXPORT Standard_Boolean | Matches (const Standard_Real X, const Standard_Real Y, const Standard_Real aTol, Standard_Real &DMin)
| Matches the coordinates X, Y with the entity found at that point within the tolerance aTol and the minimum depth DMin. You must redefine this function for every inheriting entity. You will have to call this framework inside the redefined function. .
virtual Standard_EXPORT Standard_Boolean | Matches (const Standard_Real XMin, const Standard_Real YMin, const Standard_Real XMax, const Standard_Real YMax, const Standard_Real aTol)

Matches the box defined by the coordinates Xmin,
Ymin, Xmax, Ymax with the entity found at that point
within the tolerance aTol.
Xmin, YMin define the minimum point in the lower left
hand corner of the box, and XMax, YMax define the
maximum point in the upper right hand corner of the box.
You must redefine this function for every inheriting entity.
You will have to call this framework inside the redefined function.
.

virtual Standard_EXPORT Standard_Boolean | Matches (const TColgp_Array1OfPnt2d &Polyline, const Bnd_Box2d &aBox, const Standard_Real aTol)
| prevents from hiding virtual methods...
virtual Standard_EXPORT Standard_Real | ComputeDepth (const gp_Lin &EyeLine) const
| Returns the depth of this object on the line EyeLine. EyeLine goes through the eye towards a point defined by the coordinates X,Y in the function GetEyeLine. //! gives an abcissa on <alin> . <alin> represents the line going through the eye towards an X,Y point on the screen. This Method must return a mean Depth on this line. .
virtual Standard_EXPORT void | Areas (SelectBasics_ListOfBox2d &aResult)
| to be implemented specifically by each type of sensitive primitive .
Standard_EXPORT const | Handle (Standard_Type)&DynamicType() const

## Protected Member Functions

Standard_EXPORT void | GetBox2d (Bnd_Box2d &aBox) const
Standard_EXPORT Standard_Real | FindIntersection (const TColStd_SequenceOfInteger &NodesIndices, const gp_Lin &EyeLine) const

## Private Attributes

Handle_TColgp_HArray1OfPnt | myNodes
Handle_TColgp_HArray1OfPnt2d | myNodes2d
Handle_MeshVS_HArray1OfSequenceOfInteger | myTopo
gp_XY | myCenter

## Constructor & Destructor Documentation

Standard_EXPORT MeshVS_SensitivePolyhedron::MeshVS_SensitivePolyhedron | ( | const Handle(SelectBasics_EntityOwner)& | Owner,
|  | const TColgp_Array1OfPnt & | Nodes,
|  | const Handle(MeshVS_HArray1OfSequenceOfInteger)& | Topo
| ) |

## Member Function Documentation

virtual Standard_EXPORT void MeshVS_SensitivePolyhedron::Areas | ( | SelectBasics_ListOfBox2d & | aResult | ) | `[virtual]`

| Implements SelectBasics_SensitiveEntity.

virtual Standard_EXPORT Standard_Real MeshVS_SensitivePolyhedron::ComputeDepth | ( | const gp_Lin & | EyeLine | ) | const`[virtual]`

| Implements Select3D_SensitiveEntity.

Standard_EXPORT Standard_Real MeshVS_SensitivePolyhedron::FindIntersection | ( | const TColStd_SequenceOfInteger & | NodesIndices,
|  | const gp_Lin & | EyeLine
| ) | const`[protected]`

Standard_EXPORT void MeshVS_SensitivePolyhedron::GetBox2d | ( | Bnd_Box2d & | aBox | ) | const`[protected]`

virtual Standard_EXPORT Handle_Select3D_SensitiveEntity MeshVS_SensitivePolyhedron::GetConnected | ( | const TopLoc_Location & | aLocation | ) | `[virtual]`

| Reimplemented from Select3D_SensitiveEntity.

Standard_EXPORT const MeshVS_SensitivePolyhedron::Handle | ( | Standard_Type |  | ) | const

| Reimplemented from Select3D_SensitiveEntity.

virtual Standard_EXPORT Standard_Boolean MeshVS_SensitivePolyhedron::Matches | ( | const TColgp_Array1OfPnt2d & | Polyline,
|  | const Bnd_Box2d & | aBox,
|  | const Standard_Real | aTol
| ) | `[virtual]`

| Reimplemented from Select3D_SensitiveEntity.

virtual Standard_EXPORT Standard_Boolean MeshVS_SensitivePolyhedron::Matches | ( | const Standard_Real | XMin,
|  | const Standard_Real | YMin,
|  | const Standard_Real | XMax,
|  | const Standard_Real | YMax,
|  | const Standard_Real | aTol
| ) | `[virtual]`

| Reimplemented from Select3D_SensitiveEntity.

virtual Standard_EXPORT Standard_Boolean MeshVS_SensitivePolyhedron::Matches | ( | const Standard_Real | X,
|  | const Standard_Real | Y,
|  | const Standard_Real | aTol,
|  | Standard_Real & | DMin
| ) | `[virtual]`

| Reimplemented from Select3D_SensitiveEntity.

virtual Standard_EXPORT void MeshVS_SensitivePolyhedron::Project | ( | const Select3D_Projector & | aProjector | ) | `[virtual]`

| Reimplemented from Select3D_SensitiveEntity.

## Field Documentation

gp_XY MeshVS_SensitivePolyhedron::myCenter `[private]`

Handle_TColgp_HArray1OfPnt MeshVS_SensitivePolyhedron::myNodes `[private]`

Handle_TColgp_HArray1OfPnt2d MeshVS_SensitivePolyhedron::myNodes2d `[private]`

Handle_MeshVS_HArray1OfSequenceOfInteger MeshVS_SensitivePolyhedron::myTopo `[private]`

The documentation for this class was generated from the following file:

- MeshVS_SensitivePolyhedron.hxx